
#define __USE_POSIX199309

#include <sys/time.h>
#include <sys/vfs.h>
#include <time.h>

#include <unistd.h>

#include <stdio.h>
#include <stdint.h>
#include <string.h>
#include <stdlib.h>
#include <string>
using std::string;


#define fail -1
#define success 0
#define TB 1

//***************************************************************************
// To UTF8
//***************************************************************************

int toUTF8(char* out, int outMax, const char* in)
{
   iconv_t cd;
   size_t ret;
   char* toPtr;
   char* fromPtr;
   size_t fromLen, outlen;

   const char* to_code = "UTF-8";
   const char* from_code = "ISO8859-1";

   // from_code = "ISO8859-15";

   if (!out || !in || !outMax)
      return fail;

   *out = 0;
   fromLen = strlen(in);
   
   if (!fromLen)
      return fail;
   
// #if VDRVERSNUM >= 10509
//    switch (I18nCurrentLanguage())
// #else
//    switch (Setup.OSDLanguage) 
// #endif
//    {
//       case 11: from_code = "ISO8859-7";  break;
//       case 13: 
//       case 17: from_code = "ISO8859-2";  break;
//       case 16: from_code = "ISO8859-5";  break;
//       case 18: from_code = "ISO8859-15"; break;
//       default: from_code = "ISO8859-1";  break;
// 	}

	cd = iconv_open(to_code, from_code);

   if (cd == (iconv_t)-1) 
      return fail;

   fromPtr = (char*)in;
   toPtr = out;
   outlen = outMax;

   ret = iconv(cd, &fromPtr, &fromLen, &toPtr, &outlen);

   *toPtr = 0;   
   iconv_close(cd);

   if (ret == (size_t)-1)
   {
//       tell(0, "Converting [%s] from '%s' to '%s' failed", 
//            fromPtr, from_code, to_code);

		return fail;
   }

   return success;
}

//***************************************************************************
// Text
//***************************************************************************

int text(const char* text, 
         int width, int height, int lines)
{
   int lineCount;

   int lineHeight, textWidth, pos, index, maxLines;
   string tmp = text, tmp2;

   const int maxBuf = 10000;
   char out[maxBuf+TB]; *out = 0;
   
   if (toUTF8(out, maxBuf, text) == success)
      text = out;

   lineHeight = 12;
   textWidth = strlen(text) * 20;

   if (lines != 0)
      maxLines = lines;
   else
      maxLines = height/lineHeight;

   if (maxLines <= 0)
      maxLines = 1;

   lineCount = 1;

   while (textWidth > width && textWidth > 0 && lineCount <= maxLines)
   {
      int w3 = 0;

      for (index = 1; w3 < width; ++index)
      {
         string tmp3 = tmp.substr(0, index);
         w3 = strlen(tmp3.c_str()) * 20;
      }

      tmp2 = tmp.substr(0, index+1);
      pos = tmp2.rfind(' ');

      if (pos > 0)
      {
         tmp2.resize(pos);
         tmp = tmp.substr(pos+1);
      }
      else
      {
         tmp2.resize(index-2);
         tmp = tmp.substr(index-2);
      }
      
      textWidth = strlen(tmp2.c_str()) * 20;

      printf("%s\n", tmp2.c_str());

      lineCount++;
   }

   if (lineCount <= maxLines && tmp.size() > 0)
   {
      printf("%s\n", tmp.c_str());
   }

   return lineCount;
}

//***************************************************************************
// tescht
//***************************************************************************

int main(int argc, char** argv)
{
   text("hallo xxx xxx", 40, 14, 9);
   text("\uE001\uE001\uE001\uE001\uE002", 50, 14, 9);
   text("\uE001\uE001\uE001\uE001\uE001", 50, 14, 9);
   text("?\200\201?\200\202", 50, 14, 9);

   if (argc > 1)
      text(argv[1], 100, 14, 2);

   return 0;
}


